<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */

class Glace_Fullpagecache_Helper_Target extends Glace_Fullpagecache_Helper_Data
{
    public function getCacheFilePath($pageUrl)
    {
        $booster = Mage::helper('fullpagecache')->getBooster();
        $booster->_cacheFileParams['requestUri'] = $pageUrl;
        $path = $booster->getCacheFilePath();
		return $path;
    }
    
    public function getPageLocalPath($pageUrl)
    {
    	$path = $this->getCacheFilePath($pageUrl);
    	if ($path)
    	{
	    	$isMobile = basename(dirname(dirname($path))) == 'mobile' || basename(dirname(dirname($path))) == 'tablet' ? true : false;
	    	if ($isMobile)
	    	{
				$localPath = basename(dirname(dirname($path))).DS.basename(dirname($path)).DS.basename($path);
	    	}
	    	else 
	    	{
	    		$localPath = basename(dirname($path)).DS.basename($path);
	    	}
			return $localPath;
    	}
    	else 
    	{
    		return '';
    	}
    }
    
    public function clearCacheTarget($pages)
    {
    	foreach ($pages as $pageUrl)
    	{
    		$path = $this->getCacheFilePath($pageUrl);

    		Mage::helper('fullpagecache')->_emptyFullPath(basename($path), dirname($path));
    		
    		if (strpos($path, '/media/pages/'))
    		{
	    		$pathMobile = str_replace('/media/pages/', '/media/pages/mobile/', $path);
	    		Mage::helper('fullpagecache')->_emptyFullPath(basename($pathMobile), dirname($pathMobile));
	    		
	    		$pathTablet = str_replace('/media/pages/', '/media/pages/tablet/', $path);
	    		Mage::helper('fullpagecache')->_emptyFullPath(basename($pathTablet), dirname($pathTablet));
    		}
    	}    		
    }
    
    public function clearCacheTargetByProductId($productId)
    {
    	$pages = Mage::getModel('fullpagecache/target')->getPagesByProductId($productId);
    	
    	$booster = Mage::helper('fullpagecache')->getBooster();
    	$booster->_cacheFileParams['requestUri'] = '';
    	$cachePath = dirname(dirname($booster->getCacheFilePath()));
    	
    	$isMobile = basename($cachePath) == 'mobile' || basename($cachePath) == 'tablet' ? true : false;
    	if ($isMobile)
    	{
            $cachePath = dirname($cachePath);
    	}
    	
    	foreach ($pages as $page)
    	{
	    	$filePath = $cachePath.DS.$page['page_path'];
	    	Mage::helper('fullpagecache')->_emptyFullPath(basename($filePath), dirname($filePath));
    	}
    	
    	Mage::getModel('fullpagecache/target')->removePagesByProductId($productId);
    }
}