<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */

class Glace_Fullpagecache_Model_Config_Monitor_Pages
{

    /**
     * Returns page levels as a simple array
     *
     * @return array
     */
    public function getLoadArray()
    {
        if (Mage::helper('fullpagecache')->isMonitorEnabled()) {
            $levels = Mage::helper('aitloadmon')->getGroupsArray();
            $levels = array_flip($levels);
            $firstElem = $levels[1];
            unset($levels[1]);
            $levels[1] = $firstElem;
            return $levels;
        } else {
            return array();
        }
    }


    /**
     * Returns pages levels as an array for settings
     *
     * @return array
     */
    public function toOptionArray()
    {
        $levels = $this->getLoadArray();
        if(sizeof($levels) == 0) {
            return array(
                array('value' => 0, 'label'=>Mage::helper('fullpagecache')->__('Feature can\'t be used')),
            );
        }

        $array = array(
            array('value' => 0, 'label'=>Mage::helper('fullpagecache')->__('No pages selected')),
        );

        foreach($levels as $key=>$value)
        {
            $array[] = array('value' => $key, 'label'=>Mage::helper('fullpagecache')->__(ucfirst($value)));
        }

        return $array;
    }

    /**
     * Returns page levels as an array for settings
     *
     * @return array
     */
    public function toArray()
    {
        $array = array(
            0 => Mage::helper('fullpagecache')->__('No pages selected'),
        );

        $levels = $this->getLoadArray();

        foreach($levels as $key=>$value)
        {
            $array[$key] = Mage::helper('fullpagecache')->__(ucfirst($value));
        }

        return $array;
    }
}